﻿using System.Diagnostics;
using System.Reflection;
using System.Windows;
using System;
using System.Windows.Media;
using Microsoft.VisualStudio.PlatformUI;

namespace ErikEJ.SqlCeToolbox.Dialogs
{
    /// <summary>
    /// Interaction logic for CreateLoginDialog.xaml
    /// </summary>
    public partial class AboutDialog : DialogWindow
    {

        public AboutDialog()
        {
            InitializeComponent();

        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.Background = Helpers.VSThemes.GetWindowBackground();

            Version.Text = "Version " + Assembly.GetExecutingAssembly().GetName().Version;

            txtStatus.Text = "SQL Server Compact 4.0 in GAC - ";
            try
            {
                Assembly asm4 = System.Reflection.Assembly.Load("System.Data.SqlServerCe, Version=4.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91");
                FileVersionInfo fvi = FileVersionInfo.GetVersionInfo(asm4.Location); 
                string version = fvi.FileVersion;
                txtStatus.Text += string.Format("Yes - {0}\n", version.ToString());
            }
            catch (System.IO.FileNotFoundException)
            {
                txtStatus.Text += "No\n";
            }

            txtStatus.Text += "SQL Server Compact 4.0 DbProvider - ";
            try
            {
                var factory = System.Data.Common.DbProviderFactories.GetFactory(ErikEJ.SqlCeToolbox.Resources.SqlCompact40InvariantName);
                txtStatus.Text += "Yes\n";
            }
            catch (System.Configuration.ConfigurationException)
            {
                txtStatus.Text += "No\n";
            }
            catch (ArgumentException)
            {
                txtStatus.Text += "No\n";
            }

            txtStatus.Text += "SQL Server Compact 4.0 DDEX provider - ";
            try
            {
                if (Helpers.DataConnectionHelper.ProviderIsInstalled(new Guid(ErikEJ.SqlCeToolbox.Resources.SqlCompact40Provider)))
                {
                    txtStatus.Text += "Yes\n";
                }
                else
                {
                    txtStatus.Text += "No\n";
                }
            }
            catch
            {
                txtStatus.Text += "No\n";
            }

            txtStatus.Text += "SQL Server Compact 3.5 in GAC - ";
            try
            {
                Assembly asm35 = System.Reflection.Assembly.Load("System.Data.SqlServerCe, Version=3.5.1.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91");
                FileVersionInfo fvi = FileVersionInfo.GetVersionInfo(asm35.Location);
                string version = fvi.FileVersion;
                txtStatus.Text += string.Format("Yes - {0}\n", version.ToString());
            }
            catch (System.IO.FileNotFoundException)
            {
                txtStatus.Text += "No\n";
            }

            txtStatus.Text += "SQL Server Compact 3.5 DbProvider - ";
            try
            {
                var factory = System.Data.Common.DbProviderFactories.GetFactory(ErikEJ.SqlCeToolbox.Resources.SqlCompact35InvariantName);
                txtStatus.Text += "Yes\n";
            }
            catch (System.Configuration.ConfigurationException)
            {
                txtStatus.Text += "No\n";
            }
            catch (ArgumentException)
            {
                txtStatus.Text += "No\n";
            }

            txtStatus.Text += "SQL Server Compact 3.5 DDEX provider - ";
            try
            {
                if (Helpers.DataConnectionHelper.ProviderIsInstalled(new Guid(ErikEJ.SqlCeToolbox.Resources.SqlCompact35Provider)))
                {
                    txtStatus.Text += "Yes\n";
                }
                else
                {
                    txtStatus.Text += "No\n";
                }
            }
            catch
            {
                txtStatus.Text += "No\n";
            }

            txtStatus.Text += "Sync Framework 2.1 SqlCe 3.5 provider - ";
            if (Helpers.DataConnectionHelper.IsSyncFx21Installed())
            {
                txtStatus.Text += "Yes\n";
            }
            else
            {
                txtStatus.Text += "No\n";
            }
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            //Helpers.DataConnectionHelper.LogError(new Exception(Guid.NewGuid().ToString()));
            Close();
        }

        private void CodeplexLink_Click(object sender, RoutedEventArgs e)
        {
            Process.Start("http://sqlcetoolbox.codeplex.com");
        }
    }
}