﻿using System.Windows;
using Microsoft.VisualStudio.PlatformUI;
namespace ErikEJ.SqlCeToolbox.Dialogs
{
    /// <summary>
    /// Interaction logic for RenameDialog.xaml
    /// </summary>
    public partial class RenameDialog : DialogWindow
    {
        public string NewName { get; set; }

        public RenameDialog(string tableName)
        {
            InitializeComponent();
            this.Background = Helpers.VSThemes.GetWindowBackground();
            this.Title = "Rename Table " + tableName;
            this.ServerName.Text = tableName;
        }

        private void SaveButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            SaveSettings();
            Close();
        }

        private void SaveSettings()
        {
            NewName = this.ServerName.Text;
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.ServerName.Focus();
        }

    }
}